<bugID>1353533<Summary>Creating empty maps while deleting non-existent cookies from SessionCookies.jsm's CookieStore causes jank near startup</Summary><Description>See this profile where 149ms of jank are spent deleting cookies from _updateCookie in SessionCookies.jsm: https://perf-html.io/public/ebdfb772af3c32bd7fb592ce8d0020a6b90de887/calltree/?jsOnly&amp;range=3.6613_3.9458&amp;thread=0

This is the code at http://searchfox.org/mozilla-central/rev/381a7b8f8a78b481336cfa384cb0a5536e217e4a/browser/components/sessionstore/SessionCookies.jsm#202 added in bug 1239671 for Firefox 45 and later.

This happens the first time the current session is saved (so a few seconds after the initial startup) while calling _ensureInitialized in SessionCookies.jsm.

The cookies being deleted here are the non-session cookies, which obviously aren't in the session cookies store, so for each of them _ensureMap uselessly creates empty map objects.

I think we should create a different code path for initializing SessionCookie.jsm, so that we can avoid calling _updateCookie here.

note: This jank can't be reproduced with a fresh profile, as its length depends on how many non-session cookies are stored in the profile.</Description></bugID>